<?php
/**
 * フロントエンド表示処理スクリプト
 * 
 * 金魚屋開発支援シリーズ
 * 
 * @package Joomla
 * @component com_kingyoya_contents_view
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @version 1.0.0
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
 * フロントエンドタスク表示処理
 */
class HTML_kingyoya_contents_view {

	/** @var string of option */
	var $option = null;
	/** @var int of id */
	var $id = null;

	/** @var mosContent for view */
	var $contents = null;
	/** @var mosCategory for view */
	var $category = null;
	/** @var mosSection for view */
	var $section = null;
	/** @var mosUser for created */
	var $created_by = null;
	/** @var mosUser for modified */
	var $modified_by = null;

	/** @var int of Itemid */
	var $Itemid = null;

	/** @var string of template */
	var $template = null;

	/**
	 * 表示処理
	 */
	function show() {
		$option =& $this->option;
		$id =& $this->id;
		$contents =& $this->contents;
		$category =& $this->category;
		$section =& $this->section;
		$created_by =& $this->created_by;
		$modified_by =& $this->modified_by;
		$template =& $this->template;
		$params =& $this->params;
		$Itemid =& $this->Itemid;

		if (!$option) {
			trigger_error('Failed get option', E_USER_WARNING);
			return;
		}
		if (!$id) {
			trigger_error('Failed get id', E_USER_WARNING);
			return;
		}
		if (!$contents) {
			trigger_error('Failed get contents', E_USER_WARNING);
			return;
		}
		if (!$category) {
			trigger_error('Failed get category', E_USER_WARNING);
			return;
		}
		if (!$section) {
			trigger_error('Failed get section', E_USER_WARNING);
			return;
		}
		if (!$created_by) {
			trigger_error('Failed get created_by', E_USER_WARNING);
			return;
		}
		if (!$modified_by) {
			trigger_error('Failed get modified_by', E_USER_WARNING);
			return;
		}
		if (!$template) {
			trigger_error('Failed get template', E_USER_WARNING);
			return;
		}
		if (!$params) {
			trigger_error('Failed get params', E_USER_WARNING);
			return;
		}

		if (!preg_match('/^com_[0-9a-zA-Z_]+$/', $option)) {
			trigger_error("Failed get option: {$option}", E_USER_WARNING);
			return;
		}
		if (!is_int($id) || !($id > 0)) {
			trigger_error("Failed get id: {$id}", E_USER_WARNING);
			return;
		}
		if (!is_object($contents)) {
			trigger_error("Failed get contents", E_USER_WARNING);
			return;
		}
		if (!is_object($category)) {
			trigger_error("Failed get category", E_USER_WARNING);
			return;
		}
		if (!is_object($section)) {
			trigger_error("Failed get section", E_USER_WARNING);
			return;
		}
		if (!is_object($created_by)) {
			trigger_error("Failed get created_by", E_USER_WARNING);
			return;
		}
		if (!is_object($modified_by)) {
			trigger_error("Failed get modified_by", E_USER_WARNING);
			return;
		}
		if (!is_string($template)) {
			trigger_error("Failed get template", E_USER_WARNING);
			return;
		}
		if (!is_object($params)) {
			trigger_error('Failed get params', E_USER_WARNING);
			return;
		}

		if (isset($Itemid)) {
			if (!$Itemid) {
				trigger_error('Failed get Itemid', E_USER_WARNING);
				return;
			} else if (!preg_match('/^[1-9][0-9]*$/', $Itemid)) {
				trigger_error("Failed get Itemid: {$Itemid}", E_USER_WARNING);
				return;
			}
		}

		$template = <<<__TEMPLATE__
<mos:tmpl name="contents">
{$template}
</mos:tmpl>
__TEMPLATE__;

		global $mosConfig_live_site;
		global $mosConfig_absolute_path;

		global $_MAMBOTS;
		$_MAMBOTS->loadBotGroup( 'content' );

		$contents->introtext = str_replace('{kingyoyacontentsview}', '', $contents->introtext);
		$contents->fulltext = str_replace('{kingyoyacontentsview}', '', $contents->fulltext);
		$contents->text = $contents->introtext . '{kingyoyacontentsview}'.$contents->fulltext;
		$params->set('image', true);
		$params->set('introtext', true);

		$results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$contents, &$params ), true );
		list($contents->introtext,$contents->fulltext) = explode('{kingyoyacontentsview}', $contents->text);

		require_once "{$mosConfig_absolute_path}/includes/patTemplate/patTemplate.php";
		$patTemplate = patFactory::createTemplate();
		$patTemplate->readTemplatesFromInput($template, 'String');
		$patTemplate->addVar('contents', 'id', $id);
		$patTemplate->addVar('contents', 'title', $contents->title);
		$patTemplate->addVar('contents', 'title_alias', $contents->title_alias);
		$patTemplate->addVar('contents', 'introtext', $contents->introtext);
		$patTemplate->addVar('contents', 'fulltext', $contents->fulltext);
		$patTemplate->addVar('contents', 'created', $contents->created);
		$created_by_name = $contents->created_by_alias;
		$created_by_name or $created_by_name = $created_by->name;
		$patTemplate->addVar('contents', 'created_by', $created_by_name);
		$patTemplate->addVar('contents', 'modified', $contents->modified);
		$modified_by_name = $modified_by->name;
		$modified_by_name or $modified_by_name = $contents->created_by_alias;
		$modified_by_name or $modified_by_name = $created_by->name;
		$patTemplate->addVar('contents', 'modified_by', $modified_by_name);
		$patTemplate->addVar('contents', 'publish_up', $contents->publish_up);
		$patTemplate->addVar('contents', 'publish_down', $contents->publish_down);
		$patTemplate->addVar('contents', 'category_id', $category->id);
		$patTemplate->addVar('contents', 'category_name', $category->name);
		$patTemplate->addVar('contents', 'category_title', $category->title);
		$patTemplate->addVar('contents', 'category_description', $category->description);
		$patTemplate->addVar('contents', 'category_image', "{$mosConfig_live_site}/images/stories/{$category->image}");
		$patTemplate->addVar('contents', 'section_id', $section->id);
		$patTemplate->addVar('contents', 'section_name', $section->name);
		$patTemplate->addVar('contents', 'section_title', $section->title);
		$patTemplate->addVar('contents', 'section_description', $section->description);
		$patTemplate->addVar('contents', 'section_image', "{$mosConfig_live_site}/images/stories/{$section->image}");
		$patTemplate->addVar('contents', 'br', "<br />");
		$patTemplate->displayParsedTemplate('contents');

	}

}
